Index: lemon/lgf_writer.h
===================================================================
--- lemon/lgf_writer.h	(revision 190)
+++ lemon/lgf_writer.h	(revision 192)
@@ -19,5 +19,5 @@
 ///\ingroup lemon_io
 ///\file
-///\brief Lemon Graph Format writer.
+///\brief \ref lgf-format "Lemon Graph Format" writer.
 
 
@@ -323,5 +323,5 @@
   /// \ingroup lemon_io
   ///  
-  /// \brief LGF writer for directed graphs
+  /// \brief \ref lgf-format "LGF" writer for directed graphs
   ///
   /// This utility writes an \ref lgf-format "LGF" file.
@@ -333,6 +333,6 @@
   /// with the \c nodeMap() or \c arcMap() members. An optional
   /// converter parameter can also be added as a standard functor
-  /// converting from the value type of the map to std::string. If it
-  /// is set, it will determine how the map's value type is written to
+  /// converting from the value type of the map to \c std::string. If it
+  /// is set, it will determine how the value type of the map is written to
   /// the output stream. If the functor is not set, then a default
   /// conversion will be used. The \c attribute(), \c node() and \c
@@ -340,13 +340,13 @@
   ///
   ///\code
-  ///     DigraphWriter<Digraph>(std::cout, digraph).
-  ///       nodeMap("coordinates", coord_map).
-  ///       nodeMap("size", size).
-  ///       nodeMap("title", title).
-  ///       arcMap("capacity", cap_map).
-  ///       node("source", src).
-  ///       node("target", trg).
-  ///       attribute("caption", caption).
-  ///       run();
+  /// DigraphWriter<Digraph>(std::cout, digraph).
+  ///   nodeMap("coordinates", coord_map).
+  ///   nodeMap("size", size).
+  ///   nodeMap("title", title).
+  ///   arcMap("capacity", cap_map).
+  ///   node("source", src).
+  ///   node("target", trg).
+  ///   attribute("caption", caption).
+  ///   run();
   ///\endcode
   ///
@@ -487,7 +487,7 @@
     /// @{
     
-    /// \brief Node map reading rule
-    ///
-    /// Add a node map reading rule to the writer.
+    /// \brief Node map writing rule
+    ///
+    /// Add a node map writing rule to the writer.
     template <typename Map>
     DigraphWriter& nodeMap(const std::string& caption, const Map& map) {
@@ -587,10 +587,10 @@
     }
 
-    /// \name Select section by name
+    /// \name Section captions
     /// @{
 
-    /// \brief Set \c \@nodes section to be read
-    ///
-    /// Set \c \@nodes section to be read
+    /// \brief Add an additional caption to the \c \@nodes section
+    ///
+    /// Add an additional caption to the \c \@nodes section.
     DigraphWriter& nodes(const std::string& caption) {
       _nodes_caption = caption;
@@ -598,7 +598,7 @@
     }
 
-    /// \brief Set \c \@arcs section to be read
-    ///
-    /// Set \c \@arcs section to be read
+    /// \brief Add an additional caption to the \c \@arcs section
+    ///
+    /// Add an additional caption to the \c \@arcs section.
     DigraphWriter& arcs(const std::string& caption) {
       _arcs_caption = caption;
@@ -606,7 +606,7 @@
     }
 
-    /// \brief Set \c \@attributes section to be read
-    ///
-    /// Set \c \@attributes section to be read
+    /// \brief Add an additional caption to the \c \@attributes section
+    ///
+    /// Add an additional caption to the \c \@attributes section.
     DigraphWriter& attributes(const std::string& caption) {
       _attributes_caption = caption;
@@ -619,5 +619,5 @@
     /// \brief Skip writing the node set
     ///
-    /// The \c \@nodes section will be not written to the stream.
+    /// The \c \@nodes section will not be written to the stream.
     DigraphWriter& skipNodes() {
       LEMON_ASSERT(!_skip_nodes, "Multiple usage of skipNodes() member");
@@ -628,5 +628,5 @@
     /// \brief Skip writing arc set
     ///
-    /// The \c \@arcs section will be not written to the stream.
+    /// The \c \@arcs section will not be written to the stream.
     DigraphWriter& skipArcs() {
       LEMON_ASSERT(!_skip_arcs, "Multiple usage of skipArcs() member");
@@ -836,5 +836,5 @@
     /// \brief Start the batch processing
     ///
-    /// This function starts the batch processing
+    /// This function starts the batch processing.
     void run() {
       if (!_skip_nodes) {
@@ -851,7 +851,7 @@
     }
 
-    /// \brief Gives back the stream of the writer
-    ///
-    /// Gives back the stream of the writer
+    /// \brief Give back the stream of the writer
+    ///
+    /// Give back the stream of the writer.
     std::ostream& ostream() {
       return *_os;
@@ -861,4 +861,7 @@
   };
 
+  /// \brief Return a \ref DigraphWriter class
+  /// 
+  /// This function just returns a \ref DigraphWriter class.
   /// \relates DigraphWriter
   template <typename Digraph>
@@ -869,4 +872,7 @@
   }
 
+  /// \brief Return a \ref DigraphWriter class
+  /// 
+  /// This function just returns a \ref DigraphWriter class.
   /// \relates DigraphWriter
   template <typename Digraph>
@@ -877,4 +883,7 @@
   }
 
+  /// \brief Return a \ref DigraphWriter class
+  /// 
+  /// This function just returns a \ref DigraphWriter class.
   /// \relates DigraphWriter
   template <typename Digraph>
@@ -899,7 +908,11 @@
   /// \ingroup lemon_io
   ///  
-  /// \brief LGF writer for directed graphs
+  /// \brief \ref lgf-format "LGF" writer for directed graphs
   ///
   /// This utility writes an \ref lgf-format "LGF" file.
+  ///
+  /// It can be used almost the same way as \c DigraphWriter.
+  /// The only difference is that this class can handle edges and
+  /// edge maps as well as arcs and arc maps.
   template <typename _Graph>
   class GraphWriter {
@@ -1024,7 +1037,7 @@
     /// @{
     
-    /// \brief Node map reading rule
-    ///
-    /// Add a node map reading rule to the writer.
+    /// \brief Node map writing rule
+    ///
+    /// Add a node map writing rule to the writer.
     template <typename Map>
     GraphWriter& nodeMap(const std::string& caption, const Map& map) {
@@ -1170,10 +1183,10 @@
     }
 
-    /// \name Select section by name
+    /// \name Section captions
     /// @{
 
-    /// \brief Set \c \@nodes section to be read
-    ///
-    /// Set \c \@nodes section to be read
+    /// \brief Add an additional caption to the \c \@nodes section
+    ///
+    /// Add an additional caption to the \c \@nodes section.
     GraphWriter& nodes(const std::string& caption) {
       _nodes_caption = caption;
@@ -1181,7 +1194,7 @@
     }
 
-    /// \brief Set \c \@edges section to be read
-    ///
-    /// Set \c \@edges section to be read
+    /// \brief Add an additional caption to the \c \@arcs section
+    ///
+    /// Add an additional caption to the \c \@arcs section.
     GraphWriter& edges(const std::string& caption) {
       _edges_caption = caption;
@@ -1189,7 +1202,7 @@
     }
 
-    /// \brief Set \c \@attributes section to be read
-    ///
-    /// Set \c \@attributes section to be read
+    /// \brief Add an additional caption to the \c \@attributes section
+    ///
+    /// Add an additional caption to the \c \@attributes section.
     GraphWriter& attributes(const std::string& caption) {
       _attributes_caption = caption;
@@ -1202,5 +1215,5 @@
     /// \brief Skip writing the node set
     ///
-    /// The \c \@nodes section will be not written to the stream.
+    /// The \c \@nodes section will not be written to the stream.
     GraphWriter& skipNodes() {
       LEMON_ASSERT(!_skip_nodes, "Multiple usage of skipNodes() member");
@@ -1211,5 +1224,5 @@
     /// \brief Skip writing edge set
     ///
-    /// The \c \@edges section will be not written to the stream.
+    /// The \c \@edges section will not be written to the stream.
     GraphWriter& skipEdges() {
       LEMON_ASSERT(!_skip_edges, "Multiple usage of skipEdges() member");
@@ -1419,5 +1432,5 @@
     /// \brief Start the batch processing
     ///
-    /// This function starts the batch processing
+    /// This function starts the batch processing.
     void run() {
       if (!_skip_nodes) {
@@ -1434,7 +1447,7 @@
     }
 
-    /// \brief Gives back the stream of the writer
-    ///
-    /// Gives back the stream of the writer
+    /// \brief Give back the stream of the writer
+    ///
+    /// Give back the stream of the writer
     std::ostream& ostream() {
       return *_os;
@@ -1444,4 +1457,7 @@
   };
 
+  /// \brief Return a \ref GraphWriter class
+  /// 
+  /// This function just returns a \ref GraphWriter class.
   /// \relates GraphWriter
   template <typename Graph>
@@ -1451,4 +1467,7 @@
   }
 
+  /// \brief Return a \ref GraphWriter class
+  /// 
+  /// This function just returns a \ref GraphWriter class.
   /// \relates GraphWriter
   template <typename Graph>
@@ -1458,4 +1477,7 @@
   }
 
+  /// \brief Return a \ref GraphWriter class
+  /// 
+  /// This function just returns a \ref GraphWriter class.
   /// \relates GraphWriter
   template <typename Graph>