Index: lemon/assert.h
===================================================================
--- lemon/assert.h	(revision 210)
+++ lemon/assert.h	(revision 212)
@@ -67,15 +67,15 @@
 #undef LEMON_DEBUG
 
-#if (defined(LEMON_ASSERT_LOG) ? 1 : 0) +                \
-  (defined(LEMON_ASSERT_ABORT) ? 1 : 0) +                \
+#if (defined(LEMON_ASSERT_LOG) ? 1 : 0) +               \
+  (defined(LEMON_ASSERT_ABORT) ? 1 : 0) +               \
   (defined(LEMON_ASSERT_CUSTOM) ? 1 : 0) > 1
 #error "LEMON assertion system is not set properly"
 #endif
 
-#if ((defined(LEMON_ASSERT_LOG) ? 1 : 0) +                \
-     (defined(LEMON_ASSERT_ABORT) ? 1 : 0) +                \
-     (defined(LEMON_ASSERT_CUSTOM) ? 1 : 0) == 1 ||        \
-     defined(LEMON_ENABLE_ASSERTS)) &&                        \
-  (defined(LEMON_DISABLE_ASSERTS) ||                        \
+#if ((defined(LEMON_ASSERT_LOG) ? 1 : 0) +              \
+     (defined(LEMON_ASSERT_ABORT) ? 1 : 0) +            \
+     (defined(LEMON_ASSERT_CUSTOM) ? 1 : 0) == 1 ||     \
+     defined(LEMON_ENABLE_ASSERTS)) &&                  \
+  (defined(LEMON_DISABLE_ASSERTS) ||                    \
    defined(NDEBUG))
 #error "LEMON assertion system is not set properly"
@@ -169,7 +169,7 @@
 /// behaviour is changed appropiately to the new settings.
 #  define LEMON_ASSERT(exp, msg)                                        \
-  (static_cast<void> (!!(exp) ? 0 : (                                        \
-    LEMON_ASSERT_HANDLER(__FILE__, __LINE__,                                \
-                         LEMON_FUNCTION_NAME,                                \
+  (static_cast<void> (!!(exp) ? 0 : (                                   \
+    LEMON_ASSERT_HANDLER(__FILE__, __LINE__,                            \
+                         LEMON_FUNCTION_NAME,                           \
                          ::lemon::_assert_bits::cstringify(msg), #exp), 0)))
 
@@ -185,7 +185,7 @@
 ///
 /// \see LEMON_ASSERT
-#  define LEMON_FIXME(msg)                                                \
+#  define LEMON_FIXME(msg)                                              \
   (LEMON_ASSERT_HANDLER(__FILE__, __LINE__, LEMON_FUNCTION_NAME,        \
-                        ::lemon::_assert_bits::cstringify(msg),          \
+                        ::lemon::_assert_bits::cstringify(msg),         \
                         static_cast<const char*>(0)))
 
@@ -213,8 +213,8 @@
 ///
 /// \see LEMON_ASSERT
-#  define LEMON_DEBUG(exp, msg)                                                \
-  (static_cast<void> (!!(exp) ? 0 : (                                        \
+#  define LEMON_DEBUG(exp, msg)                                         \
+  (static_cast<void> (!!(exp) ? 0 : (                                   \
     LEMON_ASSERT_HANDLER(__FILE__, __LINE__,                            \
-                         LEMON_FUNCTION_NAME,                                \
+                         LEMON_FUNCTION_NAME,                           \
                          ::lemon::_assert_bits::cstringify(msg), #exp), 0)))
 
@@ -226,21 +226,21 @@
 #    define LEMON_DEBUG(exp, msg) (static_cast<void>(0))
 #  else
-#    define LEMON_ASSERT(exp, msg)                                        \
-       (static_cast<void> (!!(exp) ? 0 : (                                \
+#    define LEMON_ASSERT(exp, msg)                                      \
+       (static_cast<void> (!!(exp) ? 0 : (                              \
         LEMON_ASSERT_HANDLER(__FILE__, __LINE__,                        \
-                             LEMON_FUNCTION_NAME,                        \
-                             ::lemon::_assert_bits::cstringify(msg),        \
+                             LEMON_FUNCTION_NAME,                       \
+                             ::lemon::_assert_bits::cstringify(msg),    \
                              #exp), 0)))
-#    define LEMON_FIXME(msg)                                                \
-       (LEMON_ASSERT_HANDLER(__FILE__, __LINE__, LEMON_FUNCTION_NAME,        \
-                             ::lemon::_assert_bits::cstringify(msg),        \
+#    define LEMON_FIXME(msg)                                            \
+       (LEMON_ASSERT_HANDLER(__FILE__, __LINE__, LEMON_FUNCTION_NAME,   \
+                             ::lemon::_assert_bits::cstringify(msg),    \
                              static_cast<const char*>(0)))
 
 #    if LEMON_ENABLE_DEBUG
 #      define LEMON_DEBUG(exp, msg)
-         (static_cast<void> (!!(exp) ? 0 : (         \
-           LEMON_ASSERT_HANDLER(__FILE__, __LINE__,  \
-                                LEMON_FUNCTION_NAME, \
-                                ::lemon::_assert_bits::cstringify(msg),     \
+         (static_cast<void> (!!(exp) ? 0 : (                            \
+           LEMON_ASSERT_HANDLER(__FILE__, __LINE__,                     \
+                                LEMON_FUNCTION_NAME,                    \
+                                ::lemon::_assert_bits::cstringify(msg), \
                                 #exp), 0)))
 #    else
@@ -250,12 +250,2 @@
 
 #endif
-
-#ifdef DOXYGEN
-
-
-#else
-
-
-#endif
-
-